#!/usr/bin/perl -w
use strict;

#	Also: watch below for others 432's and 4.3.2's...
my $v = my $vvv = '432';	# The distribution of 433 ignores -Zunderscore
$vvv =~ s/\B/./g;
#my $GCCDIR	= 'I:\gcc-432\usr';
my $GCCDIR	= "I:\\gcc-$v\\usr";
# Currently contains ./emx, ./386, ./machine; and alloca.h stdarg.h varargs.h sys/_types.h
#	setjmp.h temporarily(?) removed; looks like it is effectively identical...
my $GCC_SYSINCL = 'I:/gcc-335-sys-incl'; # Needed for vararg, alloca()?

my $pureCompile	= grep /^-[cSE]$/, @ARGV;
my $verbose	= (grep /^-v$/, @ARGV or $ENV{RUN_GCC4_VERBOSE});
my $is_omf	= grep /^-Zomf$/, @ARGV; # XXX does not default to .obj???
my $is_crtdll	= grep /^-Z(?:crtdll|mtd)$/, @ARGV;
my $is_sysv_sig	= grep /^-Zsysv-signals$/, @ARGV;	# XXX Not implemented yet

if ($is_sysv_sig) {{
  @ARGV = grep !/^-Zsysv-signals$/, @ARGV;
  last if $pureCompile;
  my $ext = $is_omf ? '.obj' : '.o';
  my @s_v = grep -f, map "$_/sigsysv$ext", split /;/, $ENV{LIBRARY_PATH};
  die "Can't find sigsysv$ext on LIBRARY_PATH, needed with -Zsysv-signals"
    unless @s_v;
  unshift @ARGV, $s_v[0];
}}

my(@a0, @a) = @ARGV;
while (@a0) {	# Remove build target
  push @a, my $o = shift @a0;
  shift @a0 if $o eq '-o';
}
my $pureLink = (grep /\.o(bj)?$/, @a and not grep /\.c(c)?$/, @a);

if ($pureLink) { # fallback to EMX linker for pure link; otherwise this library is picked up as c_dll.lib
  push @ARGV, qw(-l__alloca -Zmt);	# XXXX should be full gcc-v4.lib when available...
} else {
  #"$GCCDIR\\local432\\bin;$GCCDIR\\local432\\libexec\\gcc\\i386-pc-os2-emx\\4.3.2;$GCCDIR\\bin;$ENV{PATH}";
  $ENV{PATH} = join ';',
    ( map "$GCCDIR\\$_", "local$v\\bin",
			 "local$v\\libexec\\gcc\\i386-pc-os2-emx\\$vvv",
			 "bin" ),
    $ENV{PATH};
  #$ENV{GCCOPT} = '-pipe -mtune=i586';		#'-mfno-leading-underscore';
  $ENV{GCCOPT} = '-pipe -mtune=i586';		#'-mfno-leading-underscore';
  defined (my $blp = OS2::extLibpath || '') or die;
  OS2::extLibpath_set "$GCCDIR\\local$v\\lib;$GCCDIR\\lib;$blp" or die;
  # New linker is not looking in \mt subdirectories...
  $ENV{LIBRARY_PATH} = join ';', map( ((-d "$_/mt" ? "$_/mt" : ()), $_),
				      split /;/, $ENV{LIBRARY_PATH} );
  my $compiler_specific_includes = "";
  $ENV{C_INCLUDE_PATH} = "$GCC_SYSINCL;$ENV{C_INCLUDE_PATH}";
  $ENV{CPLUS_INCLUDE_PATH} = "$GCC_SYSINCL;$ENV{CPLUS_INCLUDE_PATH}";
  # New default for code generation is not compatible for -Zomf:
  unshift @ARGV, '-fno-leading-underscore' if $is_omf;
}
# default libraries of gcc 4.* not compatible with EMX;
# a fake c_dll.lib and this helps.  These libraries used with no options to gcc:
unless ($pureCompile) { # Probably called from configure scripts
  if ($is_crtdll) {
    push @ARGV, qw(-lc_static -lc_import -los2 -lemx2)
###  } elsif ($is_omf) {	# XXXX Why empty?
  } else {
    push @ARGV, qw(-lc_alias -lgcc -lc -lc_app -lc -lgcc -lemx -los2 -lemx2)
  }
}

warn <<EOW if $verbose;
  C_INCLUDE_PATH=$ENV{C_INCLUDE_PATH}...
  LIBRARY_PATH=$ENV{LIBRARY_PATH}...
gcc @ARGV
EOW

exit system 'gcc', @ARGV;

# i:\emx\lib\sigsysv.obj used by -Zsysv-signals
